#include <stdlib.h>
#include <stdio.h>
#include <jpeglib.h>
#include "screen.h"

int load_img(struct  VRAM_PIX *vp)
{
struct	jpeg_decompress_struct cinfo;
struct	jpeg_error_mgr jerr ;
FILE	*fp;
int     y,x,bl ;
char	*tmp_buff ;
 ;

 if( (fp=fopen("gdemos.jpg", "rb"))==NULL ){
   fprintf(stderr,"t@CI[vł܂\n") ;
   return(-1) ;
 }
 
 cinfo.err = jpeg_std_error(&jerr);
 jpeg_create_decompress(&cinfo);
 jpeg_stdio_src(&cinfo, fp);
 jpeg_read_header(&cinfo, TRUE);
 jpeg_start_decompress(&cinfo);

 bl=cinfo.output_width * cinfo.output_components ;
 tmp_buff = malloc( bl ) ;
 if( tmp_buff == NULL ) exit(-2) ;

 y=0 ;
 while( cinfo.output_scanline < cinfo.output_height ){
   jpeg_read_scanlines(&cinfo, (JSAMPARRAY)&tmp_buff, 1 );
   for( x=0 ; x<cinfo.output_width ; x++ ){
     vp[(y%512)*(VRAM_WIDTH)+x+320].r = tmp_buff[x*3+0] ;
     vp[(y%512)*(VRAM_WIDTH)+x+320].g = tmp_buff[x*3+1] ;
     vp[(y%512)*(VRAM_WIDTH)+x+320].b = tmp_buff[x*3+2] ;
   }
   y++ ;
 }

 jpeg_finish_decompress(&cinfo);
 jpeg_destroy_decompress(&cinfo);

 free( tmp_buff ) ;
 fclose( fp );
 
 return 0 ;
}
