#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"

extern int sin_tbl[] ;
extern int cos_tbl[] ;

int rot(unsigned char *vp)
{
  unsigned char *dst ;
  unsigned char *src1;
  unsigned char *src2;
  int x, y ;
  int u, v ;
  int i, o ; 
  
  dst=vp ;
  src1=vp+320*4 ;
  src2=vp+(320+200*VRAM_WIDTH)*4 ;
  for( i=256,o=0 ; i>=0 ; i-=8,o+=8 ){
    o=o%512 ;
    for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
      for( x=0 ; x<SCREEN_WIDTH ; x++ ){
	u = (((((x-160)*i/256)*cos_tbl[o]-((y-100)*i/256)*sin_tbl[o])/65536)+800)%320 ;
	v = (((((x-160)*i/256)*sin_tbl[o]+((y-100)*i/256)*cos_tbl[o])/65536)+500)%200 ;
	dst[y*VRAM_WIDTH*4+x*4+0]=src2[v*VRAM_WIDTH*4+u*4+0] ;
	dst[y*VRAM_WIDTH*4+x*4+1]=src2[v*VRAM_WIDTH*4+u*4+1] ;
	dst[y*VRAM_WIDTH*4+x*4+2]=src2[v*VRAM_WIDTH*4+u*4+2] ;
      }
    }
    GdevSync() ;
  }
  
  for( i=0,o=0 ; i<=512 ; i+=8,o+=8 ){
    o=o%512 ;
    for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
      for( x=0 ; x<SCREEN_WIDTH ; x++ ){
	u = (((((x-160)*i/256)*cos_tbl[o]-((y-100)*i/256)*sin_tbl[o])/65536)+800)%320 ;
	v = (((((x-160)*i/256)*sin_tbl[o]+((y-100)*i/256)*cos_tbl[o])/65536)+500)%200 ;
	dst[y*VRAM_WIDTH*4+x*4+0]=src2[v*VRAM_WIDTH*4+u*4+0] ;
	dst[y*VRAM_WIDTH*4+x*4+1]=src2[v*VRAM_WIDTH*4+u*4+1] ;
	dst[y*VRAM_WIDTH*4+x*4+2]=src2[v*VRAM_WIDTH*4+u*4+2] ;
      }
    }
    GdevSync() ;
  }
  return 0 ;
}
