#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"

int tile(struct  VRAM_PIX *vp)
{
  struct  VRAM_PIX *dst ;
  struct  VRAM_PIX *src1;
  struct  VRAM_PIX *src2;
  int x, y ;
  int u, v ;
  int p ; 
  
  dst=vp ;
  src1=(vp+320) ;
  src2=(vp+320+200*VRAM_WIDTH) ;
  
  for( p=128 ; p!=0 ; p=p*4/5 ){
    for( y=0 ; y<SCREEN_HEIGHT ; y+=p ){
      for( x=0 ; x<SCREEN_WIDTH ; x+=p ){
	for( v=0 ; v<p ; v++ ){
	  if( (y+v)>=SCREEN_HEIGHT ) break ;
	  for( u=0 ; u<p ; u++ ){
	    if( (x+u)>=SCREEN_WIDTH ) break ;
	    dst[(y+v)*VRAM_WIDTH+(x+u)].r=src1[y*VRAM_WIDTH+x].r*(128-p)/128 ;
	    dst[(y+v)*VRAM_WIDTH+(x+u)].g=src1[y*VRAM_WIDTH+x].g*(128-p)/128 ;
	    dst[(y+v)*VRAM_WIDTH+(x+u)].b=src1[y*VRAM_WIDTH+x].b*(128-p)/128 ;
	  }
	}
      }
    }
    GdevSync() ;
  }
  return 0 ;
}
