#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"

extern int sin_tbl[] ;
extern int cos_tbl[] ;

int zoom(struct  VRAM_PIX *vp)
{
  struct  VRAM_PIX *dst ;
  struct  VRAM_PIX *src1;
  struct  VRAM_PIX *src2;
  int x, y ;
  int u, v ;
  int z,vz ; 
  
  dst=vp ;
  src1=(vp+320) ;
  src2=(vp+320+200*VRAM_WIDTH) ;
  
  for( z=256 ; z>=0 ; z-=16 ){
    for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
      for( x=0 ; x<SCREEN_WIDTH ; x++ ){
	u = ((x-160)*z/128+480)%320 ;
	v = ((y+100)*2+300)%200 ;
	dst[y*VRAM_WIDTH+x].r=src2[v*VRAM_WIDTH+u].r ;
	dst[y*VRAM_WIDTH+x].g=src2[v*VRAM_WIDTH+u].g ;
	dst[y*VRAM_WIDTH+x].b=src2[v*VRAM_WIDTH+u].b ;
      }
    }
    GdevSync() ;
  }
  
  vz=16 ;
  for( z=0 ; z<=512 ; z+=vz ){
    for( y=0 ; y<SCREEN_HEIGHT ; y++ ){
      for( x=0 ; x<SCREEN_WIDTH ; x++ ){
	u = (((x-160)*z/128)%320+320)%320 ;
	v = (((y-100)*z/128)%200+200)%200 ;
	dst[y*VRAM_WIDTH+x].r=src2[v*VRAM_WIDTH+u].r*(512-z)/512 ;
	dst[y*VRAM_WIDTH+x].g=src2[v*VRAM_WIDTH+u].g*(512-z)/512 ;
	dst[y*VRAM_WIDTH+x].b=src2[v*VRAM_WIDTH+u].b*(512-z)/512 ;
      }
    }
    GdevSync() ;
  }
  return 0 ;
}
